/** Java class "Equal.java" generated from Poseidon for UML. 

 *  Poseidon for UML is developed by <A HREF="http://www.gentleware.com">Gentleware</A>.

 *  Generated with <A HREF="http://jakarta.apache.org/velocity/">velocity</A> template engine.

 */

package sugr;

import sugr.linalg.*;

/**
 * Contains methods if two elements are equal or not. You can retrieve then a lot 
 * of information about this test, for example: chi-value used, 
 * the testvalue and so on.
 * 
 * @author Norbert Fischer
 * @version 
 * <b> 1.1.0 (19.2.2003) </b> <br>
 * 		- Fixed: rewritten test of Line_3D/Line_3D. Now using reduced matrices
 * 			so that matrix inner dimensions agree <br>
 * 
 * <b> 1.1.1 (24.2.2003) </b> <br>
 * 		Changed: works now on copies of entities. This preserves the 
 * 			original input values from changing!!!
 * <b> 1.1.2 (17.04.2003) </b> <br>
 *     if ( (e1 instanceof Line_3D) && (e2 instanceof Line_3D) ){
 *			find an L_i*M_i >0 changed
 * <b> 2.0 (June 2003)</b> <br>
 * 		Is now derived from BiRelationalProperty !!!
 */
public class Equal extends BiRelationalProperty {
	///////////////////////////////////////
	// operations

	/** Build up an Equal relation between to Entities.
	 * @param e Entity
	 */
	public Equal(Entity e) {
		super(e, e.getClass());
	}

	/**
	 * Build up an Equal-Relation between two Point_2D. 
	 * @param x  first Point_2D
	 * @param secondClass must be Point_2D.class, only for compatibility reasons
	 */
     public Equal(Point_2D x, Class secondClass) {
		super(x, secondClass);
	} // end Equal        

	/**
	 * Build up an Equal-Relation between two Line_2D. 
	 * @param l  first Line_2D
	 * @param secondClass must be Line_2D.class, only for compatibility reasons
	 */
	public Equal(Line_2D l, Class secondClass) {
		super(l, secondClass);
	} // end Equal        

	/**
	 * Build up an Equal-Relation between two Point_3D.
	 *  
	 * @param x  first Point_3D
	 * @param secondClass must be Point_3D.class, only for compatibility reasons
	 */
	public Equal(Point_3D x, Class secondClass) {
		super(x, secondClass);
	} // end Equal         

	/**
	 * Build up an Equal-Relation between two Line_3D. 
	 * @param l  first Line_3D
	 * @param secondClass must be Line_3D.class, only for compatibility reasons
	 */
	public Equal(Line_3D l, Class secondClass) {
		super(l, secondClass);
	} // end Equal        

	/**
	 * Build up an Equal-Relation between two Plane_3D. 
	 * @param a  first Plane_3D
	 * @param secondClass must be Plane_3D.class, only for compatibility reasons
	 */
	public Equal(Plane_3D a, Class secondClass) {
		super(a, secondClass);
	} // end Equal 

	/**
	 * <p>
	 * Return Matrix Jacobian A of the first Entity and the relation type.
	 * Be careful: For estimation , the Jacobian must have another
	 * sign for Jacobian of observations and unknowns. So deliver
	 * (-1)* the Jacobian of the Entity ! (See table 3.6. on page 73 of
	 * diss of Stephan Heuel!)
	 * </p><p>
	 * 
	 * @return Matrix A
	 * </p>
	 */
	public Matrix getJacobian() {
		return first.getJacobianOfRelation(Equal.class, secondEntityType).mult(-1.0);
	}

	/**
  	  * <p>
	  * Compute degrees of freedom of that Relation
	  * </p><p>
  	  * 
	  * @return degrees of freedom of that Relation
      * </p>
  	  */
	public int getDof() {
		return first.getDofOfRelation(Equal.class, secondEntityType);
	}

	/** <p>
	 * Returns the Covariance Matrix of the row-vector of the Jacobian Matrix A of the first Entity and the relation type.
	 * </p>
	 *
	 * @param row Row vector, for which the Covariance matrix is to be returned
	 * @return covariance of the row vector of the jacobian
	 */
	public Matrix getCovarianceOfJacobianRow(int row) {
		return first.getCovarianceOfJacobianRowOfRelation(
			Equal.class,
			secondEntityType,
			row);
	}

} // end Equal
