package sugr.GUI;

import sugr.*;

/** Wrapper Class for complex estimation call. This
    class can be used in Matlab to get the values
    of an Estimation in a simple way.
    @author Thomas Laebe, ipb
*/
public class EstimationWrapper
{
	static public double sigma0;
	static public int    no_of_iterations;

	/** Call estimation function and deliver sigma0 and no_of_iterations
        in class variables. */
	static public boolean estimate(Element e, RelationalProperty[] rprops,
								   boolean doConditioning, int maxiter, RelationalProperty[] yhat) {
		double [] a_sigma0=new double[1];
		int [] a_no_of_iterations= new int[1];
		boolean retvalue=e.estimate(rprops, doConditioning, maxiter, yhat, a_sigma0, a_no_of_iterations, true);
		sigma0=a_sigma0[0];
		no_of_iterations=a_no_of_iterations[0];
		return retvalue;
	}
}
